package jp.sewig.aloemascot {
	import flash.display.NativeWindow;
	import flash.display.NativeWindowInitOptions;
	import flash.display.NativeWindowResize;
	import flash.display.NativeWindowSystemChrome;
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageDisplayState;
	import flash.display.StageScaleMode;
	import flash.display.Loader;
	import flash.events.ContextMenuEvent;
	import flash.events.Event;
	import flash.events.KeyboardEvent;
	import flash.events.MouseEvent;
	import flash.system.Shell;
	import flash.ui.ContextMenu;
	import flash.ui.ContextMenuItem;
	import flash.ui.Keyboard;
	import flash.net.URLRequest;
	import flash.media.Sound;
	import flash.media.SoundChannel;
	import flash.filesystem.File;

	public class MascotWindow extends NativeWindow {
		// private static var GRIPPER_SIZE:uint = 20;
		private var sprite:Sprite;

		private var exitMenuItem:ContextMenuItem;
		private var viewSource:ContextMenuItem;
		
		// app-storage:
		private var path:URLRequest = new URLRequest("app-resource:/mascot.mp3");
		
		public function MascotWindow(width:uint = 240, height:uint = 320, x:uint = 50, y:uint = 50, alpha:Number = 1.0) {
			var winArgs:NativeWindowInitOptions = new NativeWindowInitOptions();
			winArgs.systemChrome = NativeWindowSystemChrome.NONE;
			winArgs.transparent = true;
			super(winArgs);

			// Windowの設定
			this.title = "マスコット";
			this.alwaysInFront = true;
			this.x = x;
			this.y = y;
			this.width = width;
			this.height = height;
			// this.paintsDefaultBackground = false;

			// Spriteの作成
			sprite = new Sprite();
			sprite.alpha = alpha;
			sprite.useHandCursor = true;
			
			// 画像
			var loader:Loader = new Loader();
			loader.load(new URLRequest("app-resource:/mascot.png"));
			loader.doubleClickEnabled = true;
			loader.addEventListener(MouseEvent.DOUBLE_CLICK, onDoubleClick);
            sprite.addChild(loader);

			// コンテキストメニューの作成
			stage.showDefaultContextMenu = true;
			var cm:ContextMenu = new ContextMenu();
			cm.hideBuiltInItems();
			exitMenuItem = new ContextMenuItem("終了");
			exitMenuItem.addEventListener(ContextMenuEvent.MENU_ITEM_SELECT, onExitMenuItem);
			cm.customItems.push(exitMenuItem);
			sprite.contextMenu = cm;

			// Stageの設定
			stage.align = StageAlign.TOP_LEFT;
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.addChild(sprite);

			// Listenerの設定
			// this.addEventListener(Event.RESIZE, onWindowResize);
			sprite.doubleClickEnabled = true;
			sprite.addEventListener(MouseEvent.DOUBLE_CLICK, onDoubleClick);
			sprite.addEventListener(MouseEvent.MOUSE_DOWN, onMouseDown);
			// sprite.addEventListener(MouseEvent.MOUSE_WHEEL, onMouseWheel);
			// stage.addEventListener(KeyboardEvent.KEY_DOWN, onKeyDown);
			
			drawTicks();
			visible = true;
		}
		
		private function drawTicks():void {
			/*
			sprite.graphics.clear();
			sprite.graphics.beginFill(0xffffff);
			sprite.graphics.drawRect(0, 0, width, height);
			sprite.graphics.endFill();
			*/
		}
		
		private function onExitMenuItem(e:ContextMenuEvent):void {
			Shell.shell.exit();
			// close();
		}
		
		/*
		private function onWindowResize(e:Event):void {
			drawTicks();
		}
		*/
		
		private function onDoubleClick(e:Event):void {
			var s:Sound = new Sound();
			s.load(path);
			var channel:SoundChannel = s.play(0);
			// channel.addEventListener(Event.SOUND_COMPLETE, soundComplete);
		}
		
		/*
		private function soundComplete(e:Event):void {
			trace("complete");
		}
		*/
		
		private function onMouseDown(e:Event):void {
			startMove();
			/*
			if (stage.mouseX >= 0 && stage.mouseX <= GRIPPER_SIZE && stage.mouseY >= 0 && stage.mouseY <= GRIPPER_SIZE) {
				startResize(NativeWindowResize.TOP_LEFT);
			}
			else if (stage.mouseX <= this.width && stage.mouseX >= this.width - GRIPPER_SIZE && stage.mouseY >= 0 && stage.mouseY <= GRIPPER_SIZE) {
				startResize(NativeWindowResize.TOP_RIGHT);					
			}
			else if (stage.mouseX >= 0 && stage.mouseX <= GRIPPER_SIZE && stage.mouseY <= this.height && stage.mouseY >= this.height - GRIPPER_SIZE) {
				startResize(NativeWindowResize.BOTTOM_LEFT);					
			}
			else if (stage.mouseX <= this.width && stage.mouseX >= this.width - GRIPPER_SIZE && stage.mouseY <= this.height && stage.mouseY >= this.height - GRIPPER_SIZE) {
				startResize(NativeWindowResize.BOTTOM_RIGHT);					
			}
			else if (stage.mouseX >= 0 && stage.mouseX <= GRIPPER_SIZE) {
				startResize(NativeWindowResize.LEFT);					
			}
			else if (stage.mouseX >= this.width - GRIPPER_SIZE && stage.mouseX <= this.width) {
				startResize(NativeWindowResize.RIGHT);					
			}
			else if (stage.mouseY >= 0 && stage.mouseY <= GRIPPER_SIZE) {
				startResize(NativeWindowResize.TOP);					
			}
			else if (stage.mouseY >= this.height - GRIPPER_SIZE && stage.mouseY <= this.height) {
				startResize(NativeWindowResize.BOTTOM);					
			}
			else {
				startMove();
			}
			*/
		}
		
		/*
		private function onMouseWheel(e:MouseEvent):void {
			var delta:int = (e.delta < 0) ? -1 : 1;
		}
		*/
		
		/*
		private function onKeyDown(e:KeyboardEvent):void {
			switch (e.keyCode) {
				case Keyboard.DOWN:
					if (e.shiftKey)
						
					else
						
					break;
				case Keyboard.UP:
					if (e.shiftKey)
						
					else
						
					break;
				case Keyboard.RIGHT:
					if (e.shiftKey)
						
					else
						
					drawTicks();
					break;
				case Keyboard.LEFT:
					if (e.shiftKey)
						
					else
						
					drawTicks();
					break;
			}
		}
		*/
	}
}
